PLASMA 2.8.0 PLASMA - Parallel Linear Algebra for Scalable Multi-core Architectures

- Main Page
- Modules
- Data Types List

int PLASMA_dsgesv | ( | int | N,
|  | int | NRHS,
|  | double * | A,
|  | int | LDA,
|  | int * | IPIV,
|  | double * | B,
|  | int | LDB,
|  | double * | X,
|  | int | LDX,
|  | int * | ITER
| ) |  |

PLASMA_dsgesv - Computes the solution to a system of linear equations A * X = B, where A is an N-by-N matrix and X and B are N-by-NRHS matrices.

PLASMA_dsgesv first attempts to factorize the matrix in COMPLEX and use this factorization within an iterative refinement procedure to produce a solution with COMPLEX*16 normwise backward error quality (see below). If the approach fails the method switches to a COMPLEX*16 factorization and solve.

The iterative refinement is not going to be a winning strategy if the ratio COMPLEX performance over COMPLEX*16 performance is too small. A reasonable strategy should take the number of right-hand sides and the size of the matrix into account. This might be done with a call to ILAENV in the future. Up to now, we always try iterative refinement.

The iterative refinement process is stopped if ITER > ITERMAX or for all the RHS we have: RNRM < N*XNRM*ANRM*EPS*BWDMAX where:

- ITER is the number of the current iteration in the iterative refinement process
- RNRM is the infinity-norm of the residual
- XNRM is the infinity-norm of the solution
- ANRM is the infinity-operator-norm of the matrix A
- EPS is the machine epsilon returned by DLAMCH('Epsilon').

Actually, in its current state (PLASMA 2.1.0), the test is slightly relaxed.

The values ITERMAX and BWDMAX are fixed to 30 and 1.0D+00 respectively.

Parameters

  [in] | N | The number of linear equations, i.e., the order of the matrix A. N >= 0.
  [in] | NRHS | The number of right hand sides, i.e., the number of columns of the matrix B. NRHS >= 0.
  [in] | A | The N-by-N coefficient matrix A. This matrix is not modified.
  [in] | LDA | The leading dimension of the array A. LDA >= max(1,N).
  [out] | IPIV | On exit, the pivot indices that define the permutations.
  [in] | B | The N-by-NRHS matrix of right hand side matrix B.
  [in] | LDB | The leading dimension of the array B. LDB >= max(1,N).
  [out] | X | If return value = 0, the N-by-NRHS solution matrix X.
  [in] | LDX | The leading dimension of the array B. LDX >= max(1,N).
  [out] | ITER | The number of the current iteration in the iterative refinement process

Returns

Return values

  PLASMA_SUCCESS | successful exit
  <0 | if -i, the i-th argument had an illegal value
  >0 | if i, U(i,i) is exactly zero. The factorization has been completed, but the factor U is exactly singular, so the solution could not be computed.

See also
  PLASMA_dsgesv_Tile
  PLASMA_dsgesv_Tile_Async
  PLASMA_dsgesv
  PLASMA_dgesv